   pro rdbegemann_al2o3,nopr,iout,indir,outdir,lstrn,iset,lset,$
   nlines,wcm,wavelength,rndat,ridat,iwave

; ***
; Choose which temperature and rays to work with

   nfiles=2
   files=strarr(nfiles)
  files(0)='begemann_al2o3_porous.nc'
  files(1)='begemann_al2o3_compact.nc'

; ****
   print,'  Specify which Begemann Al2O3 to work with'
  for i=0,nfiles-1 do begin
   i2=i+1
   print,' iset=',i2,' ',files(i)
  endfor
  print,'  Specify iset 1 or 2'

  read,iset

   fil=strarr(1)
   fil=files(iset-1)

; ***
; Read in the data from the netCDF file

; For graphs
   lset=lstrn

; ***
; The input netCDF file
  filnm=strcompress(indir+fil)

; Open the netCDF file
  nc_id=ncdf_open(filnm)

; ***
  idnlines=ncdf_varid(nc_id,'nlines')
  ncdf_varget,nc_id,idnlines,nlines

  idntext=ncdf_varid(nc_id,'ntext')
  ncdf_varget,nc_id,idntext,ntext

  idn70=ncdf_varid(nc_id,'n70')
  ncdf_varget,nc_id,idn70,n70

; print,n70,ntext,nlines

; ****
; text=strarr(n70,ntext)
  idtext=ncdf_varid(nc_id,'text')
  ncdf_varget,nc_id,idtext,text
  text=string(text)

; *****
; Read in the data
  idwcm=ncdf_varid(nc_id,'wcm')
  idwavelength=ncdf_varid(nc_id,'wavelength')
  idrn=ncdf_varid(nc_id,'rn')
  idri=ncdf_varid(nc_id,'ri')

; ***
; Get data
  ncdf_varget,nc_id,idwcm,wcm
  ncdf_varget,nc_id,idwavelength,wavelength
  ncdf_varget,nc_id,idrn,rndat
  ncdf_varget,nc_id,idri,ridat

; ****
; Close the data set
  ncdf_close,nc_id

; *****
  if (nopr eq 1) then begin

    printf,iout,'  '
    printf,iout,'  rdbegemann_al2o3: filnm ',filnm
    printf,iout,'  rdbegemann_al2o3: nlines ',nlines
    printf,iout,'  '
    printf,iout,'  rdbegemann_al2o3: text(i)'
   for i=0,ntext-1 do begin
    printf,iout,text(i)
   endfor

   printf,iout,'  '
   printf,iout,'   rdbegemann_al2o3: i,wcm,wavelength,rndat and ridat'
   for i=0,nlines-1 do begin
    printf,iout,'  ',i,wcm(i),wavelength(i),rndat(i),ridat(i)
   endfor

  endif

; ******
  return
  end
